Index: trunk/LMDZ.TITAN/libf/muphytitan/string_op.F90
===================================================================
--- trunk/LMDZ.TITAN/libf/muphytitan/string_op.F90	(revision 3082)
+++ trunk/LMDZ.TITAN/libf/muphytitan/string_op.F90	(revision 3083)
@@ -2404,12 +2392,12 @@
 
   SUBROUTINE fis_affect_double(str,double)
-    !! Assignment subroutine (using intrinsic real(kind=8)) 
+    !! Assignment subroutine (using intrinsic real(kind=8))
     CHARACTER(len=:), INTENT(out), ALLOCATABLE :: str    !! Output string to be assigned
-    REAL(kind=8), INTENT(in)                   :: double !! Input value to assign 
+    REAL(kind=8), INTENT(in)                   :: double !! Input value to assign
     str = fis_cat_double('',double)
   END SUBROUTINE fis_affect_double
 
   SUBROUTINE fis_affect_cplx(str,cplx)
-    !! Assignment subroutine (using intrinsic complex) 
+    !! Assignment subroutine (using intrinsic complex)
     CHARACTER(len=:), INTENT(out), ALLOCATABLE :: str  !! Output string to be assigned
     COMPLEX(kind=4), INTENT(in)                :: cplx !! Input value to assign
@@ -2418,5 +2406,5 @@
 
   SUBROUTINE fis_affect_dcplx(str,dcplx)
-    !! Assignment subroutine (using intrinsic complex(kind=8)) 
+    !! Assignment subroutine (using intrinsic complex(kind=8))
     CHARACTER(len=:), INTENT(out), ALLOCATABLE :: str   !! Output string to be assigned
     COMPLEX(kind=8), INTENT(in)                :: dcplx !! Input value to assign
@@ -2429,5 +2417,5 @@
     !! Only know CSI codes are returned. If no known CSI are found the outputput vector is
     !! allocated with 0 elements.
-    CHARACTER(len=2), DIMENSION(:), INTENT(in) :: flags !! CSI attributes flags 
+    CHARACTER(len=2), DIMENSION(:), INTENT(in) :: flags !! CSI attributes flags
     INTEGER, DIMENSION(:), ALLOCATABLE :: codes         !! CSI codes.
     INTEGER :: i,j,n
@@ -2454,10 +2442,10 @@
   FUNCTION fancy_fstr(value,flags,fmt) RESULT(output)
     !! Compute a fancy string from the given (fortran intrinsic) string.
-    CHARACTER(len=*), INTENT(in)               :: value  !! String object reference 
+    CHARACTER(len=*), INTENT(in)               :: value  !! String object reference
     CHARACTER(len=2), DIMENSION(:), INTENT(in) :: flags  !! CSI attributes flags
     CHARACTER(len=*), INTENT(in), OPTIONAL     :: fmt    !! Optional format (unused for this overload)
     CHARACTER(len=:), ALLOCATABLE              :: output !! Output fortran instrinsic string
     INTEGER, DIMENSION(:), ALLOCATABLE :: codes
-    codes = get_attrs_indexes(flags) 
+    codes = get_attrs_indexes(flags)
     IF (SIZE(codes) == 0) THEN
       output = value ; RETURN
@@ -2469,11 +2457,11 @@
   FUNCTION fancy_int(value,flags,fmt) RESULT(output)
     !! Compute a fancy string from the given integer value.
-    INTEGER, INTENT(in)                        :: value  !! String object reference 
+    INTEGER, INTENT(in)                        :: value  !! String object reference
     CHARACTER(len=2), DIMENSION(:), INTENT(in) :: flags  !! CSI attributes flags
     CHARACTER(len=*), INTENT(in), OPTIONAL     :: fmt    !! Optional format. If given it must be a valid Fortran format.
     CHARACTER(len=:), ALLOCATABLE              :: output !! Output fortran instrinsic string
     INTEGER, DIMENSION(:), ALLOCATABLE :: codes
-    CHARACTER(len=:), ALLOCATABLE      :: tmp 
-    codes = get_attrs_indexes(flags) 
+    CHARACTER(len=:), ALLOCATABLE      :: tmp
+    codes = get_attrs_indexes(flags)
     IF (PRESENT(fmt)) THEN ; tmp = to_string(value,fmt) ; ELSE ; tmp = to_string(value) ; ENDIF
     IF (SIZE(codes) /= 0) THEN ; output = add_csi(tmp,codes) ; ELSE ; output = tmp ; ENDIF
@@ -2482,11 +2470,11 @@
   FUNCTION fancy_bool(value,flags,fmt) RESULT(output)
     !! Compute a fancy string from the given logical value.
-    LOGICAL, INTENT(in)                        :: value  !! String object reference 
+    LOGICAL, INTENT(in)                        :: value  !! String object reference
     CHARACTER(len=2), DIMENSION(:), INTENT(in) :: flags  !! CSI attributes flags
     CHARACTER(len=*), INTENT(in), OPTIONAL     :: fmt    !! Optional format. If given it must be a valid Fortran format.
     CHARACTER(len=:), ALLOCATABLE              :: output !! Output fortran instrinsic string
     INTEGER, DIMENSION(:), ALLOCATABLE :: codes
-    CHARACTER(len=:), ALLOCATABLE      :: tmp 
-    codes = get_attrs_indexes(flags) 
+    CHARACTER(len=:), ALLOCATABLE      :: tmp
+    codes = get_attrs_indexes(flags)
     IF (PRESENT(fmt)) THEN ; tmp = to_string(value,fmt) ; ELSE ; tmp = to_string(value) ; ENDIF
     IF (SIZE(codes) /= 0) THEN ; output = add_csi(tmp,codes) ; ELSE ; output = tmp ; ENDIF
@@ -2495,24 +2483,24 @@
   FUNCTION fancy_real(value,flags,fmt) RESULT(output)
     !! Compute a fancy string from the given real value (simple precision).
-    REAL(kind=4), INTENT(in)                   :: value  !! String object reference 
+    REAL(kind=4), INTENT(in)                   :: value  !! String object reference
     CHARACTER(len=2), DIMENSION(:), INTENT(in) :: flags  !! CSI attributes flags
     CHARACTER(len=*), INTENT(in), OPTIONAL     :: fmt    !! Optional format. If given it must be a valid Fortran format.
     CHARACTER(len=:), ALLOCATABLE              :: output !! Output fortran instrinsic string
     INTEGER, DIMENSION(:), ALLOCATABLE :: codes
-    CHARACTER(len=:), ALLOCATABLE      :: tmp 
-    codes = get_attrs_indexes(flags) 
+    CHARACTER(len=:), ALLOCATABLE      :: tmp
+    codes = get_attrs_indexes(flags)
     IF (PRESENT(fmt)) THEN ; tmp = to_string(value,fmt) ; ELSE ; tmp = to_string(value) ; ENDIF
     IF (SIZE(codes) /= 0) THEN ; output = add_csi(tmp,codes) ; ELSE ; output = tmp ; ENDIF
-  END FUNCTION fancy_real 
+  END FUNCTION fancy_real
 
   FUNCTION fancy_double(value,flags,fmt) RESULT(output)
     !! Compute a fancy string from the given real value (double precision).
-    REAL(kind=8), INTENT(in)                   :: value  !! String object reference 
+    REAL(kind=8), INTENT(in)                   :: value  !! String object reference
     CHARACTER(len=2), DIMENSION(:), INTENT(in) :: flags  !! CSI attributes flags
     CHARACTER(len=*), INTENT(in), OPTIONAL     :: fmt    !! Optional format. If given it must be a valid Fortran format.
     CHARACTER(len=:), ALLOCATABLE              :: output !! Output fortran instrinsic string
     INTEGER, DIMENSION(:), ALLOCATABLE :: codes
-    CHARACTER(len=:), ALLOCATABLE      :: tmp 
-    codes = get_attrs_indexes(flags) 
+    CHARACTER(len=:), ALLOCATABLE      :: tmp
+    codes = get_attrs_indexes(flags)
     IF (PRESENT(fmt)) THEN ; tmp = to_string(value,fmt) ; ELSE ; tmp = to_string(value) ; ENDIF
     IF (SIZE(codes) /= 0) THEN ; output = add_csi(tmp,codes) ; ELSE ; output = tmp ; ENDIF
@@ -2521,24 +2509,24 @@
   FUNCTION fancy_cplx(value,flags,fmt) RESULT(output)
     !! Compute a fancy string from the given complex value (simple precision).
-    COMPLEX(kind=4), INTENT(in)                :: value  !! String object reference 
+    COMPLEX(kind=4), INTENT(in)                :: value  !! String object reference
     CHARACTER(len=2), DIMENSION(:), INTENT(in) :: flags  !! CSI attributes flags
     CHARACTER(len=*), INTENT(in), OPTIONAL     :: fmt    !! Optional format. If given it must be a valid Fortran format.
     CHARACTER(len=:), ALLOCATABLE              :: output !! Output fortran instrinsic string
     INTEGER, DIMENSION(:), ALLOCATABLE :: codes
-    CHARACTER(len=:), ALLOCATABLE      :: tmp 
-    codes = get_attrs_indexes(flags) 
+    CHARACTER(len=:), ALLOCATABLE      :: tmp
+    codes = get_attrs_indexes(flags)
     IF (PRESENT(fmt)) THEN ; tmp = to_string(value,fmt) ; ELSE ; tmp = to_string(value) ; ENDIF
     IF (SIZE(codes) /= 0) THEN ; output = add_csi(tmp,codes) ; ELSE ; output = tmp ; ENDIF
   END FUNCTION fancy_cplx
-  
+
   FUNCTION fancy_dcplx(value,flags,fmt) RESULT(output)
     !! Compute a fancy string from the given complex value (double precision).
-    COMPLEX(kind=8), INTENT(in)                :: value  !! String object reference 
+    COMPLEX(kind=8), INTENT(in)                :: value  !! String object reference
     CHARACTER(len=2), DIMENSION(:), INTENT(in) :: flags  !! CSI attributes flags
     CHARACTER(len=*), INTENT(in), OPTIONAL     :: fmt    !! Optional format. If given it must be a valid Fortran format.
     CHARACTER(len=:), ALLOCATABLE              :: output !! Output fortran instrinsic string
     INTEGER, DIMENSION(:), ALLOCATABLE :: codes
-    CHARACTER(len=:), ALLOCATABLE      :: tmp 
-    codes = get_attrs_indexes(flags) 
+    CHARACTER(len=:), ALLOCATABLE      :: tmp
+    codes = get_attrs_indexes(flags)
     IF (PRESENT(fmt)) THEN ; tmp = to_string(value,fmt) ; ELSE ; tmp = to_string(value) ; ENDIF
     IF (SIZE(codes) /= 0) THEN ; output = add_csi(tmp,codes) ; ELSE ; output = tmp ; ENDIF
Index: trunk/LMDZ.TITAN/libf/phytitan/calc_condlh.F90
===================================================================
--- trunk/LMDZ.TITAN/libf/phytitan/calc_condlh.F90	(revision 3083)
+++ trunk/LMDZ.TITAN/libf/phytitan/calc_condlh.F90	(revision 3083)
@@ -0,0 +1,136 @@
+subroutine calc_condlh(ngrid,nlayer,pt,Lcx)
+
+use tracer_h
+
+implicit none
+
+!====================================================================
+!
+!   Purpose
+!   -------
+!   Computes latent heat of condensation [J.kg-1] for ice tracers
+!
+!   INPUT
+!   -----
+!   ngrid   = Number of grid points in the chunk [-]
+!   nlayer  = Number of vertical layers [-]
+!   pt      = Temperature [K]
+!
+!   OUTPUT
+!   ------
+!   Lcx = Condensation latente heat [J.kg-1]
+!
+!   Author(s)
+!   ---------
+!   B. de Batz de Trenquelléon (07/2023)
+!
+!   !!! WARNING !!!
+!   ---------------
+!   We suppose a given order of tracers !
+!   CH4  --> 1
+!   C2H2 --> 2
+!   C2H6 --> 3
+!   HCN  --> 4 (TO DO)
+!====================================================================    
+
+
+!------------------------------------
+! 0. DECLARATIONS
+!------------------------------------
+
+! Inputs :
+!---------
+integer, intent(in) :: ngrid
+integer, intent(in) :: nlayer
+real, intent(in)    :: pt(ngrid,nlayer)
+
+! Outputs :
+!----------
+real, intent(out) :: Lcx(ngrid,nlayer,size(ices_indx))
+
+! Parameters :
+!-------------
+real, parameter :: mmolCH4  = 16.e-3 ! Molar mass of CH4 [kg.mol-1]
+real, parameter :: mmolC2H2 = 26.e-3 ! Molar mass of C2H2 [kg.mol-1]
+real, parameter :: mmolC2H6 = 30.e-3 ! Molar mass of C2H6 [kg.mol-1]
+real, parameter :: mmolHCN  = 27.e-3 ! Molar mass of HCN [kg.mol-1]
+
+real, parameter :: TcCH4  = 190.56 ! Critical point of CH4  [K]
+real, parameter :: TcC2H2 = 308.35 ! Critical point of C2H2 [K]
+real, parameter :: TcC2H6 = 305.35 ! Critical point of C2H6 [K]
+real, parameter :: TcHCN  = 456.70 ! Critical point of HCN [K]
+
+! Local variables :
+!------------------
+integer :: iq, ig, l
+real*8  :: ftx ! Variables for latente heat [-]
+
+
+!------------------------------------
+! 1. INITIALISATION
+!------------------------------------
+
+do iq = 1, size(ices_indx) ! For each species
+
+    ! CH4 :
+    !------
+    if(trim(nameOfTracer(gazs_indx(iq))) .eq. "CH4") then
+        
+        do ig = 1, ngrid ! Main loop on the horizontal grid
+            do l = 1, nlayer ! Loop on vertical layers
+                ftx = (1. - pt(ig,l)) / TcCH4
+                if (ftx .le. 1.e-3) ftx = 1.e-3
+                Lcx(ig,l,iq) = 8.314 * TcCH4 * (7.08 * ftx**0.354 + 10.95 * 1.1e-2 * ftx**0.456) / mmolCH4
+            enddo ! End of loop on vertical layers
+        enddo ! End of main loop on the horizontal grid
+
+
+    ! C2H2 :
+    !-------
+    else if(trim(nameOfTracer(gazs_indx(iq))) .eq. "C2H2") then
+
+        do ig = 1, ngrid ! Main loop on the horizontal grid
+            do l = 1, nlayer ! Loop on vertical layers       
+                ftx = (1. - pt(ig,l)) / TcC2H2
+                if (ftx .le. 1.e-3) ftx = 1.e-3
+                Lcx(ig,l,iq) = 8.314 * TcC2H2 * (7.08 * ftx**0.354 + 10.95 * 1.9e-1 * ftx**0.456) / mmolC2H2
+            enddo ! End of loop on vertical layers
+        enddo ! End of main loop on the horizontal grid
+
+
+    ! C2H6 :
+    !-------
+    else if(trim(nameOfTracer(gazs_indx(iq))) .eq. "C2H6") then
+        
+        do ig = 1, ngrid ! Main loop on the horizontal grid
+            do l = 1, nlayer ! Loop on vertical layers
+                ftx = (1. - pt(ig,l)) / TcC2H6
+                if (ftx .le. 1.e-3) ftx = 1.e-3
+                Lcx(ig,l,iq) = 8.314 * TcC2H6 * (7.08 * ftx**0.354 + 10.95 * 9.9e-2 * ftx**0.456) / mmolC2H6
+            enddo ! End of loop on vertical layers
+        enddo ! End of main loop on the horizontal grid
+
+
+    ! HCN :
+    !------
+    else if(trim(nameOfTracer(gazs_indx(iq))) .eq. "HCN") then
+
+        do ig = 1, ngrid ! Main loop on the horizontal grid
+            do l = 1, nlayer ! Loop on vertical layers
+                ftx = (1. - pt(ig,l)) / TcHCN
+                if (ftx .le. 1.e-3) ftx = 1.e-3
+                Lcx(ig,l,iq) = 8.314 * TcHCN * (7.08 * ftx**0.354 + 10.95 * 3.88e-1 * ftx**0.456) / mmolHCN
+            enddo ! End of loop on vertical layers
+        enddo ! End of main loop on the horizontal grid
+
+
+    else
+        write(*,*) 'Species ',trim(nameOfTracer(gazs_indx(iq))),' not considered... Check traceur.def'
+        Lcx(ig,l,iq) = 0.0D0
+    endif
+
+enddo ! End of species
+
+return
+
+end subroutine calc_condlh
Index: trunk/LMDZ.TITAN/libf/phytitan/calc_rayleigh.F90
===================================================================
--- trunk/LMDZ.TITAN/libf/phytitan/calc_rayleigh.F90	(revision 3082)
+++ trunk/LMDZ.TITAN/libf/phytitan/calc_rayleigh.F90	(revision 3083)
@@ -14,4 +14,5 @@
 !     Robin Wordsworth (2010)
 !     Jeremy Leconte (2012): Added option for variable gas. Improved water rayleigh (Bucholtz 1995).
+!     Bruno de Batz de Trenquelleon (2023) : Added CH4 rayleigh.
 !
 !     Called by
@@ -28,5 +29,5 @@
       use radcommon_h, only: WAVEV, BWNV, DWNV, tstellar, tauray, scalep
       use gases_h
-      use comcstfi_mod, only: g, mugaz
+      use comcstfi_mod, only: g, mugaz, pi
 
       implicit none
@@ -46,15 +47,26 @@
       integer icantbewrong
 
-      ! tau0/p0=tau/p (Hansen 1974)
-      ! Then calculate tau0 = (8*pi^3*p_1atm)/(3*N0^2) * 4*delta^2/(g*mugaz*lambda^4)
-      ! where delta=n-1 and N0 is an amagat
+       ! we multiply by scalep here (100) because plev, which is used in optcv,
+       ! is in units of mBar, so we need to convert.
+       ! we calculate here TAURAY which is in m2/mBar
+
+       ! tau0/p0=tau/p (Hansen 1974 : equation (2.31) )
+       ! Then calculate tau0 = (8*pi^3*p_1atm)/(3*N0^2) * 4*delta^2/(g*mugaz*lambda^4) (Hansen 1974 : equation (2.29) )
+       ! where delta=n-1 and N0 is an amagat
+
+       ! In exo_k : (8*pi^3)/(3*N0^2) * 4 * delta^2 ------- is written : (24*pi^3)/(N0^2) * (4/9) * delta^2
+
+       ! (tauconsti * tauvari) = scalep * cross_section_molecule_exo_k /  ( gravity * molecular_mass )
+       ! (tauconsti * tauvari) in m2/mBar because of scalep factor
+       ! cross_section_molecule in m2/molecule
+       ! molecular_mass is the mass of th considered molecule
 
       typeknown=.false.
       do igas=1,ngasmx
-	 if(gfrac(igas,nivref).lt.5.e-2)then
+	 if(gfrac(igas,nivref).lt.1.e-2)then
             print*,'Ignoring ',trim(gnom(igas)),' in Rayleigh scattering '// &
-            'as its mixing ratio is less than 0.05.' 
+            'as its mixing ratio is less than 0.01.' 
             ! ignore variable gas in Rayleigh calculation
-            ! ignore gases of mixing ratio < 0.05 in Rayleigh calculation
+            ! ignore gases of mixing ratio < 0.01 in Rayleigh calculation
             tauconsti(igas) = 0.0
          else
@@ -66,4 +78,13 @@
                ! uses n=1.000132 from Optics, Fourth Edition.
                ! was out by a factor 2!
+	    elseif(igas.eq.igas_CH4)then
+                ! For CH4 we use the formalism of exo_k (developed by Jeremy Leconte)
+                ! the relation between exo_k formalism and LMDZ formalism is : (tauconsti*tauvari)=scalep*sigma_exok/(gravity*molecular_mass)
+                ! Values are taken from Caldas (2019), equation 12 & appendix D
+                ! 24.*pi**3/(1E5/(1.380648813E-23*273.15))**2 is a constant
+                ! 4/9=(2/3)**2 is approximately ((n+1)/(n**2+2))**2
+                ! 1E24 = (1E6)**4 because wavelength is in micron
+                ! 16.04*1.6726*1E-27 is CH4 molecular mass
+                tauconsti(igas) = 24.*pi**3/(1E5/(1.380648813E-23*273.15))**2 * 4./9. * 1E24 * (1/( g *16.04*1.6726*1E-27))  * scalep             
             else
                print*,'Error in calc_rayleigh: Gas species not recognised!'
@@ -96,7 +117,7 @@
             tauvar=0.0
             do igas=1,ngasmx
-               if(gfrac(igas,nivref).lt.5.e-2)then
+               if(gfrac(igas,nivref).lt.1.e-2)then
                   ! ignore variable gas in Rayleigh calculation
-                  ! ignore gases of mixing ratio < 0.05 in Rayleigh calculation
+                  ! ignore gases of mixing ratio < 0.01 in Rayleigh calculation
                   tauvari(igas)   = 0.0
                else
@@ -105,4 +126,6 @@
                   elseif(igas.eq.igas_H2)then
                      tauvari(igas) = 1.0/wl**4 
+		  elseif(igas.eq.igas_CH4)then
+                      tauvari(igas) = (4.6662E-4+4.02E-6/wl**2)**2 / wl**4
                   else
                      print*,'Error in calc_rayleigh: Gas species not recognised!'
Index: trunk/LMDZ.TITAN/libf/phytitan/calc_ysat.F90
===================================================================
--- trunk/LMDZ.TITAN/libf/phytitan/calc_ysat.F90	(revision 3082)
+++ trunk/LMDZ.TITAN/libf/phytitan/calc_ysat.F90	(revision 3083)
@@ -28,5 +28,5 @@
   INTEGER, INTENT(IN)                           :: nlon  ! # of grid points in the chunk
   INTEGER, INTENT(IN)                           :: nlay  ! # of vertical layes 
-  REAL, DIMENSION(nlon,nlay),      INTENT(IN)   :: press ! Mid-layers pressure (Pa)
+  REAL, DIMENSION(nlon,nlay),      INTENT(IN)   :: press ! Mid-layers pressure (!!! mbar !!!)
   REAL, DIMENSION(nlon,nlay),      INTENT(IN)   :: temp  ! Mid-layers temperature (K)
   REAL, DIMENSION(nlon,nlay,nkim), INTENT(OUT)  :: ysat  ! Saturation profiles (mol/mol)
@@ -49,12 +49,16 @@
      if(trim(cnames(ic)).eq."CH4") then
 
-        where (temp(:,:).lt.90.65)                                      
-           ysat(:,:,ic) = 10.0**(4.42507e0 - ( ( ( 1165560.7e0 / temp(:,:)                  &
-                -  115352.19e0 ) / temp(:,:) + 4055.6016e0 ) / temp(:,:)                    &
-                + 453.92414e0 ) / temp(:,:) ) / press(:,:) * 1013.25e0
-        elsewhere
-           ysat(:,:,ic) = 10.0**(3.901408e0 - ( ( 154567.02e0 / temp(:,:) - 1598.8512e0 )   &
-                / temp(:,:) + 437.54809e0 ) / temp(:,:)) / press(:,:) * 1013.25e0
-        endwhere
+        !where (temp(:,:).lt.90.65)                                      
+        !   ysat(:,:,ic) = 10.0**(4.42507e0 - ( ( ( 1165560.7e0 / temp(:,:)                  &
+        !        -  115352.19e0 ) / temp(:,:) + 4055.6016e0 ) / temp(:,:)                    &
+        !        + 453.92414e0 ) / temp(:,:) ) / press(:,:) * 1013.25e0
+        !elsewhere
+        !   ysat(:,:,ic) = 10.0**(3.901408e0 - ( ( 154567.02e0 / temp(:,:) - 1598.8512e0 )   &
+        !        / temp(:,:) + 437.54809e0 ) / temp(:,:)) / press(:,:) * 1013.25e0
+        !endwhere
+
+        ! Fray and Schmidt (2009)
+        ysat(:,:,ic) = (1000. / press(:,:)) * exp(1.051e1 - 1.110e3/temp(:,:)              &
+                       - 4.341e3/temp(:,:)**2 + 1.035e5/temp(:,:)**3 - 7.910e5/temp(:,:)**4)
 
         ! Forcing CH4 to 1.4% minimum               
@@ -66,5 +70,5 @@
 !             * alog10(1.0e3/temp(:,:)) ) / press(:,:)*1013.25e0/760.0
 
-         ysat(:,:,ic) = 1.E5 * exp(13.4-2536./temp(:,:)) / press(:,:) ! Fray and Schmidt (2009)
+         ysat(:,:,ic) = (1000. / press(:,:)) * exp(1.340e1 - 2.536e3/temp(:,:)) ! Fray and Schmidt (2009)
 
      else if(trim(cnames(ic)).eq."C2H4") then
@@ -87,14 +91,17 @@
      else if(trim(cnames(ic)).eq."C2H6") then
 
-        where (temp(:,:).lt.90.)
-!           ysat(:,:,ic) = 10.0**(10.01e0-1085.0e0/(temp(:,:)-0.561e0) )                     &
+!        where (temp(:,:).lt.90.)
+!           ysat(:,:,ic) = 10.0**(10.01e0-1085.0e0/(temp(:,:)-0.561e0) )                    &
 !                / press(:,:) * 1013.25e0 / 760.0e0
-           ysat(:,:,ic) = 1.E5 * exp ( 15.11 - 2207./temp(:,:) - 24110./(temp(:,:)**2)       &
-                        + 7.744E5/(temp(:,:)**3) - 1.161E7/(temp(:,:)**4)                    &
-                        + 6.763E7/(temp(:,:)**5) ) / press(:,:) ! Fray and Schmidt (2009)
-        elsewhere
-           ysat(:,:,ic) = 10.0**(5.9366e0 - 1086.17e0/temp(:,:) + 3.83464e0                 &
-                * alog10(1.0e3/temp(:,:)) ) / press(:,:)*1013.25e0/760.0
-        endwhere
+!           ysat(:,:,ic) = 1.E5 * exp ( 15.11 - 2207./temp(:,:) - 24110./(temp(:,:)**2)     &
+!                        + 7.744E5/(temp(:,:)**3) - 1.161E7/(temp(:,:)**4)                  &
+!                        + 6.763E7/(temp(:,:)**5) ) / press(:,:) ! Fray and Schmidt (2009)
+!        elsewhere
+!           ysat(:,:,ic) = 10.0**(5.9366e0 - 1086.17e0/temp(:,:) + 3.83464e0                &
+!                * alog10(1.0e3/temp(:,:)) ) / press(:,:)*1013.25e0/760.0
+!        endwhere
+         ysat(:,:,ic) = (1000. / press(:,:)) * exp(1.511e1 - 2.207e3/temp(:,:)            &
+                      - 2.411e4/temp(:,:)**2 + 7.744e5/temp(:,:)**3 - 1.161e7/temp(:,:)**4  &
+                      + 6.763e7/temp(:,:)**5)
 
      else if((trim(cnames(ic)).eq."CH3CCH") .or. (trim(cnames(ic)).eq."CH2CCH2")) then
@@ -150,7 +157,7 @@
 
         !ysat(:,:,ic)= 10.0**(8.6165e0 - 1516.5e0/(temp(:,:) - 26.2e0) ) / press(:,:) * 1013.25e0 / 760.0e0
-        
-        ysat(:,:,ic) = 1.E5 * exp ( 13.93 - 3624./temp(:,:) - 1.325E5/(temp(:,:)**2)       &
-                     + 6.314E6/(temp(:,:)**3) - 1.128E8/(temp(:,:)**4) ) / press(:,:)  ! Fray and Schmidt (2009)
+
+        ysat(:,:,ic) = (1000. / press(:,:)) * exp (1.393e1 - 3.624e3/temp(:,:)             &
+                     - 1.325e5/temp(:,:)**2 + 6.314e6/temp(:,:)**3 - 1.128e8/temp(:,:)**4) ! Fray and Schmidt (2009)
 
      else if(trim(cnames(ic)).eq."CH3CN")  then
